package moca.core.proxy.actions.adapters;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.apache.log4j.Logger;

import moca.core.proxy.ClientInfo;
import moca.core.proxy.actions.adapters.AdaptationException;
import moca.core.proxy.actions.adapters.Adapter;
import moca.core.proxy.message.Message;


/**
 * @author Hana
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AggregatedAdapter extends Adapter {
	
	private static final Logger LOGGER = Logger.getLogger(AggregatedAdapter.class);
	
	private Collection adapters = new ArrayList();
	public void addAdapter(Adapter adapt) {
		this.adapters.add(adapt);
	}
	public Message execute(ClientInfo clientInfo, Message msg)  throws AdaptationException{
		Iterator it = adapters.iterator();
		while (it.hasNext()) {
			Adapter adapt = (Adapter) it.next();
			try {
				msg = adapt.execute(clientInfo, msg);
			} catch (AdaptationException e) {
				LOGGER.warn(
						"Error during  " + adapt.getClass() + ".execute()",
						e);
				//TODO -- 
				//Talvez tenha que criar um mecanismo de dependncia, que indique se
				//houver falha na anterior, se a prxima deve ou no ser executada....
				//Talvez pudesse ter 2 tipos de exceo, uma que indica que pode prosseguir 
				//e outra que indica que deve parar.
				
				//if(???)
				//	 throw e;

			}
			if (msg == null) {
				//se o ultimo adapter retornou null, no continue as adaptaes
				break;
			}
			
		}
		return msg;
	}
	
	/**
	* Compara dois objetos
	*/
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (obj.getClass() != this.getClass()) {
			return false;
		}
		AggregatedAdapter agg = (AggregatedAdapter) obj;
		return agg.adapters.equals(this.adapters);
	}

}
