/*
 * Created on 18/11/2004
 */
package moca.core.proxy.communication.async;

import moca.core.proxy.ProxyException;
import moca.core.proxy.communication.CommunicationProtocol;
import moca.core.proxy.communication.ServerCommunication;
import moca.core.proxy.message.Message;
import moca.protocol.eci.client.listenersmanager.EventListener;
import moca.util.eci.Event;


/**
 * Treat notifications received from the server, via asynchronous communication.
 * The notification (event) data is passed to the proxy application (implementation of the framework)
 * 
 * @author hana
 *
 */
public class ReceiveServerNotification implements EventListener {

	ServerCommunication communicator = null;
	 
	/**
	 * Constructor.
	 */
	public ReceiveServerNotification(ServerCommunication communic) {
		this.communicator = communic;
	}

	/* (non-Javadoc)
	 * @see moca.protocol.pubsub.subscriber.EventListener#onReceiveData(moca.protocol.pubsub.Event)
	 */
	public void onReceiveData(Event event) {
		//Repassar para a aplicao cliente a mensagem
		ReceivedEvent newEvent = new ReceivedEvent(event);
		
		Thread th = new Thread(newEvent);
		th.start();
	}

	
  // Tratar eventos recebidos do servidor
	private class ReceivedEvent implements Runnable{
				
		Event event;
		
		public ReceivedEvent(Event e){
			event = e;			
		}
		
		/* (non-Javadoc)
		 * @see java.lang.Runnable#run()
		 */
		public void run() {
		
			Message m = (Message) event.getData();
			CommunicationProtocol cm = null;
					
			try {
			//	 Enviar a msg para a aplicao, junto com o protocolo
			   cm = new CommunicationProtocol(CommunicationProtocol.TCP,CommunicationProtocol.ASYNC);
		} catch (ProxyException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
			cm.setAddress(communicator.getEsSubscriber().getLocalAddress());
			
			//	encaminhar a mensagem
			communicator.notifyReceivedMessage(m,cm);
		}
	}
	
}
