package moca.core.proxy.receivers;

/**
 * Mensagem de controle para o Receiver controlador dos eventos do CIS
 * @author hana
 */
public class CISMessage implements ReceiverMessage {
	/**
	 * indice do estado ao qual se refere a mensagem
	 */
	private int stateIndex;
	/**
	* indica qual transio ocorreu. true se o estado monitorado ocorreu
	* e false se o estado monitorado deixou de ocorrer
	*/
	private boolean isOn;
	/**
	* Identificador do cliente cuja mudana de estado foi observada
	*/
	private String clientId;
	/**
	 * Construtor
	 * @param clientId identificador do cliente
	 * @param stateIndex indice do estado
	 * @param isOn tipo de mudana (on se o estado ocorreu e falso se o estado
	 * deixou de ocorrer)
	 */
	public CISMessage(String clientId, int stateIndex, boolean isOn) {
		this.stateIndex = stateIndex;
		this.isOn = isOn;
		this.clientId = clientId;
	}

	/**
	 * retorna o identificador do cliente
	 * @return id do cliente
	 */
	public String getClientId() {
		return clientId;
	}

	/**
	 * retorna o tipo do estado
	 * @return tipo da mudana de estado (on = true ou off = false)
	 */
	public boolean isOn() {
		return isOn;
	}

	/**
	 * indice do estado
	 * @return indice
	 */
	public int getStateIndex() {
		return stateIndex;
	}

}
