package moca.core.proxy.state.xml;

import moca.core.proxy.state.Expression;
import org.apache.log4j.Logger;
import org.w3c.dom.Element;

/**
 * Faz a leitura das expressoes
 * @author hana
 */
public class ExpressionXMLReader {
	private static final Logger LOGGER = Logger.getLogger(ExpressionXMLReader.class);

	public static Expression read(Element el) {
		if (!el.getNodeName().equals("Expression")) {
			LOGGER.error("Tag Expression esperada. Encontrada: " + el.getNodeName());
			return null;
		}
		String val = ConfiguratorXML.getElementValue(el);
		if (val == null || val.trim().equals("")) {
			LOGGER.error("Expression no pode ser nula!");
			return null;
		} 
		return new Expression(val);
	}
}
